package cn.com.qmth.examcloud.tool.task;

import cn.com.qmth.examcloud.tool.utils.SpringContextHelper;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.context.annotation.Configuration;

import javax.annotation.PostConstruct;

@Configuration
@EnableConfigurationProperties(TaskProperties.class)
@ConditionalOnProperty(prefix = "examcloud.task", name = "active", havingValue = "true")
public class TaskConfig {

    private final static Logger log = LoggerFactory.getLogger(TaskConfig.class);

    @Autowired
    private TaskProperties taskProperties;

    @PostConstruct
    public void init() throws Exception {
        log.info("task init... " + taskProperties.getImpl());

        Class<Task> clazz = (Class<Task>) Class.forName(taskProperties.getImpl());
        Task task = SpringContextHelper.getBean(clazz);
        task.start(taskProperties.getParams());
    }

}